#!/usr/bin/env python
# -*- coding: utf-8 -*-

# importe la bibliothèque Pygame
import pygame
from pygame.locals import *
import os
import sys

# indique le chemin du dossier
chemin_fichier = sys.argv[0]
chemin1 = os.path.abspath(chemin_fichier)
chemin = os.path.dirname(chemin1) + '/'
print chemin

# chemin des images personnelles
data_file = 'data/'

print data_file

currentPath = chemin + data_file
dirFiles = os.listdir(currentPath) 
numFiles = len(dirFiles)
    
print currentPath
print numFiles
print dirFiles[0]
print dirFiles[1]

# nom des images contenues dans le dossier data
image1 = dirFiles[0]
image2 = dirFiles[1]

print image1
print image2

# définit les images choisies pour l'arrière-plan  et la souris sans le chemin de leur dossier
nom_image_arriereplan = 'arriereplan.png'
nom_image_arriereplan_cote = 'arriereplan_cote.png'
nom_image_arriereplan_cote2 = 'arriereplan_cote2.png'
nom_image_arriereplan1 = image1
nom_image_arriereplan2 = image2
nom_image_victoire = 'tux_victoire.png'
nom_image_defaite = 'tux_defaite.png'
nom_image_souris1 = 'miks_static.png'
nom_image_souris2 = 'miks_smackup2.png'
nom_image_souris3 = 'miks_roll2.png'
nom_image_souris1b = 'miks_walk2.png'

# définit les images choisies pour l'arrière-plan  et la souris avec le chemin du dossier
image_arriereplan = chemin + nom_image_arriereplan
image_arriereplan_cote = chemin + nom_image_arriereplan_cote
image_arriereplan_cote2 = chemin + nom_image_arriereplan_cote2
image_arriereplan1 = chemin + data_file + nom_image_arriereplan1
image_arriereplan2 = chemin + data_file + nom_image_arriereplan2
image_victoire = chemin + nom_image_victoire
image_defaite = chemin + nom_image_defaite
image_souris1 = chemin + nom_image_souris1
image_souris2 = chemin + nom_image_souris2
image_souris3 = chemin + nom_image_souris3
image_souris1b = chemin + nom_image_souris1b

# appelle la fonction horloge et le temps
clock = pygame.time.Clock()
temps = pygame.time.get_ticks()
temps2 = clock.get_time()

#initialise pygame
pygame.init()

# initialise les variables
i = 0
k = 0
score = 0

# définit la taille de la fenêtre
screen = pygame.display.set_mode((800, 472), 0, 32)
# donne le titre de la fenêtre
pygame.display.set_caption("Miks aime le bleu")

# charge les images
arriereplan = pygame.image.load(image_arriereplan).convert()
arriereplan_cote = pygame.image.load(image_arriereplan_cote).convert()
arriereplan_cote2 = pygame.image.load(image_arriereplan_cote2).convert_alpha()
arriereplan1 = pygame.image.load(image_arriereplan1).convert()
arriereplan2 = pygame.image.load(image_arriereplan2).convert()
victoire = pygame.image.load(image_victoire).convert()
defaite = pygame.image.load(image_defaite).convert()
souris1 = pygame.image.load(image_souris1).convert_alpha()
souris2 = pygame.image.load(image_souris2).convert_alpha()
souris3 = pygame.image.load(image_souris3).convert_alpha()
souris1b = pygame.image.load(image_souris1b).convert_alpha()

# récupère la largeur et la hauteur de l'image d'arrière-plan
largeur_arriereplan = arriereplan.get_width()
hauteur_arriereplan = arriereplan.get_height()

# divise et réduit la largeur et la hauteur d'arrière-plan
width = largeur_arriereplan/2-18
height = hauteur_arriereplan/2-12

# crée les vignettes de la page accueil
arriereplan1p = pygame.transform.scale(arriereplan1, (width, height))
arriereplan2p = pygame.transform.scale(arriereplan2, (width, height))

# définit les couleurs
bleu = (50, 100, 255, 255)
rouge = (255, 0, 0, 255)
vert = (0, 255, 0)
jaune = (255, 255, 0)
blanc = (255, 255, 255)
orange = (255, 128, 0)

# indique les scores maximums et minimums
score_max = 3000
score_min = -3000

# fonction d'affichage de la souris suivant la couleur de l'arrière-plan
def rendu_miks():  
    """ si la couleur est bleue, change k et donc l'image de la souris """
    if couleur_ecran != bleu and couleur_ecran != rouge:
        if temps%2 == 0:   
            k = 0
            pygame.time.wait(100)
        else:
            k = 3
            pygame.time.wait(100)  
    if couleur_ecran == bleu: 
        if temps%2 == 0:     
            k = 0
            pygame.time.wait(100)            
        else:
            k = 1
            pygame.time.wait(200)       
    elif couleur_ecran == rouge:
        if temps%2 == 0:       
            k = 0
            pygame.time.wait(100)            
        else:
            k = 2
            pygame.time.wait(200)
    """ affiche l'image de la souris """
    screen.blit(souris_x[k], (x,y))

def imprime_texte(texte,x_texte):
    """ affiche du texte à l'écran avec la police et la couleur choisie """
    ma_police = pygame.font.SysFont("arial", 100)
    surface_texte = ma_police.render(texte, True, vert)
    screen.blit(surface_texte, (x_texte, height+(height/2)))

def accueil_jeu():
    """ Définit les dimensions du rectangle de la page d'accueil """ 
    Rect = (6, 16, largeur_arriereplan-12, height+12) 
    i = 0
    """ remplit l'écran de blanc """
    screen.fill((255,255,255))
    """ crée un rectangle vert """
    pygame.draw.rect(screen, vert, Rect, 0)
    """ affiche successivement la première vignette et la deuxième sur la page d'accueil """ 
    screen.blit(arriereplan1p, (10, 20)) 
    screen.blit(arriereplan2p, ((width+24), 20)) 
    """ affiche l'image de la souris """
    k = 0
    screen.blit(souris_x[k], (x,y))

def verifie_score():
    """ affiche le score réel puis le temps dans la console """
    print score
    print temps
    """ affiche le nombre de nounours correspondant au score affiché """
    if score2 == 0:
        screen.blit(souris_x[0], ((largeur_arriereplan+30), 20))
    if score2 < 0:
        for s in range(0,3):
            if score2 < -s:
                screen.blit(souris_x[2], ((largeur_arriereplan+30), (20+s*80)))      
        for s in range(0,3):
            if score2 < -(s+3):
                screen.blit(souris_x[2], ((largeur_arriereplan+130), (20+s*80))) 
    if score2 > 0:     
        for s in range(0,3):
            if score2 > s:
                screen.blit(souris_x[1], ((largeur_arriereplan+30), (20+s*80)))      
        for s in range(0,3):
            if score2 > (s+3):
                screen.blit(souris_x[1], ((largeur_arriereplan+130), (20+s*80)))

while True:
    # pour fermer la fenêtre
    for event in pygame.event.get():
        if event.type == QUIT:
            exit()
    # inscrémente le temps depuis le début du jeu
    temps += 1

    # récupère les touches pressées
    touche_pressee = pygame.key.get_pressed()

    #tableau des images pour l'arrière-plan
    arriereplan_x = [arriereplan, arriereplan1, arriereplan2]

    screen.blit(arriereplan_cote, (608, 0)) 

    # choisit l'image d'arrière-plan selon la touche
    if  touche_pressee[K_KP1]:
        i = 1
        
    elif touche_pressee[K_KP2]:
        i = 2
                
    elif touche_pressee[K_KP0]:
        i = 0
    # affiche l'arrière-plan en fonction de la touche pressée, connue grâce à la variable i
    screen.blit(arriereplan_x[i], (0, 0))

    # définit la position de la souris
    x, y = pygame.mouse.get_pos()
    
    # échantillonne la couleur que survole la souris
    couleur_ecran = screen.get_at((x, y))

    # tableau des images utilisées pour la souris
    souris_x = [souris1, souris2, souris3, souris1b] 

    # Place le curseur de la souris au centre de l'image
    x-= souris_x[k].get_width() / 2
    y-= souris_x[k].get_height() / 2
 
    # Si on presse la touche 0
    if i == 0:
        # appelle la fonction qui affiche la page d'accueil
        accueil_jeu()
        # affiche les chiffres 1 puis 2 grâce à al fonction d'affichage de texte
        imprime_texte("1", width-(width/2))
        imprime_texte("2", width+(width/2))

    # si la touche 1 ou la touche 2 sont pressés
    elif i == 1 or i == 2:
        # divise le score par 500 pour des chiffres plus petits et un changement moins rapide
        score2 = score/10
        # si la couleur est bleue, on ajoute 1 au score
        if couleur_ecran == bleu and score2 < 6:
            score +=1
        # si la couleur est rouge, on ote 1 au score 
        if couleur_ecran == rouge and score2 > -6:
            score -=1
        # appelle la fonction d'affichage l'image de la souris
        rendu_miks()

        # appelle la fonction de vérification du score
        verifie_score()  
        
        # transforme le chiffre du petit score en texte à afficher
        texte_score = str(score2)
        # affiche le petit score sur l'écran grâce à la fonction d'affichage de texte
        if score2 >= -6 and score2 <=6:
            imprime_texte(texte_score,(largeur_arriereplan + 40))        

        # si le score dépasse le maximum et que la partie jaune est atteinte, affiche l'image de la victoire
        if score2 >= 6 and couleur_ecran == jaune:
            screen.blit(victoire, (0, 0))
            screen.blit(arriereplan_cote2, (608, 0))
            score += 3000
            
        if score > 3000:
            screen.blit(victoire, (0, 0))
            screen.blit(arriereplan_cote2, (608, 0))        
                
        # si le score est inférieur au minimum, affiche l'image de la défaite
        if score2 <= -6:
            score -=10000
            screen.blit(defaite, (0, 0)) 
            screen.blit(arriereplan_cote2, (608, 0)) 
              
    # réactualise l'affichage
    pygame.display.flip()
